<?xml version="1.0"?>
<xs:schema version="1.0"
           xmlns:xs="http://www.w3.org/2001/XMLSchema"
           elementFormDefault="qualified">
    <xs:element name="students">
        <xs:complexType>
            <xs:sequence>
                <xs:element name="student" maxOccurs="unbounded" minOccurs="0">
                    <xs:complexType>
                        <xs:sequence>
                            <xs:element name="name">
                                <xs:complexType>
                                    <xs:sequence>
                                        <xs:element type="xs:string" name="firstName"/>
                                        <xs:element type="xs:string" name="lastName"/>
                                    </xs:sequence>
                                </xs:complexType>
                            </xs:element>
                            <xs:element name="address">
                                <xs:complexType>
                                    <xs:sequence>
                                        <xs:element type="xs:byte" name="houseNumber"/>
                                        <xs:element type="xs:byte" name="floor" minOccurs="0"/>
                                        <xs:element type="xs:string" name="doorNumber" minOccurs="0"/>
                                        <xs:element type="xs:string" name="street"/>
                                        <xs:element type="xs:int" name="postCode"/>
                                        <xs:element type="xs:string" name="city"/>
                                    </xs:sequence>
                                </xs:complexType>
                            </xs:element>
                            <xs:element type="xs:string" name="major" maxOccurs="unbounded" minOccurs="0"/>
                            <xs:element name="results">
                                <xs:complexType>
                                    <xs:sequence>
                                        <xs:element name="result" maxOccurs="unbounded" minOccurs="0">
                                            <xs:complexType>
                                                <xs:simpleContent>
                                                    <xs:extension base="xs:string">
                                                        <xs:attribute type="xs:string" name="course" use="optional"/>
                                                        <xs:attribute type="xs:byte" name="grade" use="optional"/>
                                                    </xs:extension>
                                                </xs:simpleContent>
                                            </xs:complexType>
                                        </xs:element>
                                    </xs:sequence>
                                </xs:complexType>
                            </xs:element>
                        </xs:sequence>
                        <xs:attribute type="xs:int" name="id" use="optional"/>
                        <xs:attribute type="xs:byte" name="age" use="optional"/>
                        <xs:attribute type="xs:string" name="tutored" use="optional"/>
                    </xs:complexType>
                </xs:element>
            </xs:sequence>
        </xs:complexType>
    </xs:element>
</xs:schema>
